using System;

namespace Spojler
{
    class Program
    {
        public static long Memoizacija(long m, long n, long[,] matrica, long[,] memo)
        {
            if (memo[m, n] != -1) return memo[m, n];
            if (m == 0 && n == 0) return memo[m, n] = matrica[m, n];
            if (m == 0) return memo[m, n] = matrica[m, n] + Memoizacija(m, n - 1, matrica, memo);
            else if (n == 0) return matrica[m, n] + Memoizacija(m - 1, n, matrica, memo);

            if (Memoizacija(m - 1, n, matrica, memo) < Memoizacija(m, n - 1, matrica, memo)) return memo[m, n] = matrica[m, n] + Memoizacija(m - 1, n, matrica, memo);
            else return memo[m, n] = matrica[m, n] + Memoizacija(m, n - 1, matrica, memo);
        }
        public static long[,] Memo(long N, long M)
        {
            long[,] memo = new long[N + 1, M + 1];
            for (int i = 0; i <= N; i++)
            {
                for (int j = 0; j <= M; j++)
                    memo[i, j] = -1;

            }
            return memo;
        }
        static void Main(string[] args)
        {          
            string[] c1 = Console.ReadLine().Split(' ');
            long N = Convert.ToInt64(c1[0]);
            long M = Convert.ToInt64(c1[1]);
            long[,] doha = new long[N, M];
            for (int i = 0; i < N; i++)
            {
                string[] c2 = Console.ReadLine().Split(' ');
                for (int j = 0; j < M; j++) 
                    doha[i,j]= Convert.ToInt64(c2[j]);
            }

            long[,] memo = new long[N + 1, M + 1];

            long Q = Convert.ToInt64(Console.ReadLine());
            long[] resenja = new long[Q];
            long k = 0;
            while (k<Q)
            {
                string[] c3 = Console.ReadLine().Split(' ');
                long n1 = Convert.ToInt64(c3[0]) - 1;
                long m1 = Convert.ToInt64(c3[1]) - 1;
                memo = Memo(N, M);
                memo[n1, m1] = 6 * doha[n1, m1];
                resenja[k]=Memoizacija(N - 1, M - 1, doha, memo);
                k ++;
            }
            k = 0;
            while (k < Q)
            {
                Console.WriteLine(resenja[k]); k++;
            }
 
        }
    }
}